﻿using System;
using System.ServiceModel;
using System.Threading;
using Artech.UnityIntegrationDemo.Contracts;

namespace Artech.UnityIntegrationDemo.Client
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ChannelFactory<ISyncTimeProvision> channelFactory = new ChannelFactory<ISyncTimeProvision>("synctimeprovisionservice"))
            {
                ISyncTimeProvision proxy = channelFactory.CreateChannel();
                using (proxy as IDisposable)
                {
                    try
                    {
                        for (int i = 0; i < 5; i++)
                        {
                            Console.WriteLine("The current time is {0}", proxy.GetCurrentTime());
                            Thread.Sleep(1000);
                        }
                    }
                    catch (CommunicationException)
                    {
                        (proxy as ICommunicationObject).Abort();
                        throw;
                    }
                    catch (TimeoutException)
                    {
                        (proxy as ICommunicationObject).Abort();
                        throw;
                    }
                }
            }

            Console.Read();
        }
    }
}
